#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

map<string, string> params;

int parse(const string &val) {
    if (val.find('e') != string::npos) {
        int m = stoi(val.substr(0, val.find('e')));
        int exp = stoi(val.substr(val.find('e') + 1, val.size()));
        int now = 1;
        for (int _ = 0; _ < exp; _++) {
            now *= 10;
        }
        return m * now;
    } else {
        return stoi(val);
    }
}


int get(const string &name, int def = 0) {
    if (params.count(name)) {
        return parse(params[name]);
    } else {
        return def;
    }
}


int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    for (int i = 1; i < argc; i++) {
        string maxS = string(argv[i]);
        if (maxS.find('=') != string::npos) {
            auto pos = maxS.find('=');
            params[maxS.substr(0, pos)] = maxS.substr(pos + 1);
        } else {
            params[maxS] = "";
        }
    }

    int maxS = get("maxS");
    vector <int> wrong_dp(maxS + 1);
    for (int k = 1; k <= maxS; k++) {
        int p = k;
        while (p > 0) {
            int l = 2;
            while ((l * (l + 1)) / 2 <= p) {
                l++;
            }
            wrong_dp[k] += l;
            p -= ((l * (l - 1))) / 2;
        }
    }

    vector <int> ok_dp(maxS + 1, INT_MAX);
    ok_dp[0] = 0;
    for (int pre_val = 0; pre_val < maxS; pre_val++) {
        for (int sm = 1, i = 1; pre_val + sm <= maxS; i++, sm += i) {
            if (ok_dp[pre_val + sm] > ok_dp[pre_val] + i + 1) {
                ok_dp[pre_val + sm] = ok_dp[pre_val] + i + 1;
            }
        }
    }

    for (int i = maxS; i >= 1; i--) {
        for (int start = 0; start <= i; start++) {
            int min_ok = INT_MAX, min_wa = INT_MAX;
            for (int j = 0; ; j++) {
                int pre = start * (j + 1) + j * (j + 1) / 2;
                if (pre > i) {
                    break;
                }
                min_ok = min(min_ok, ok_dp[i - pre] + j + 1);
                min_wa = min(min_wa, wrong_dp[i - pre] + j + 1);
            }
            if (min_ok < min_wa) {
                cout << min_ok << " " << start << " " << 1 << " " << i << endl;
                return 0;
            }
        }
    }
    return 0;
}
