#include "testlib.h"
#include <iostream>
#include <vector>
#include <cassert>

using namespace std;

#define ll long long
#define pb emplace_back

const int INF = 1e9 + 10;

map<string, string> params;

long long get(string name, long long def = 0) {
    if (params.count(name)) {
        return stoll(params[name]);
    } else {
        return def;
    }
}

const int MAXS = 200'000;
const int MAXN = 200'000;
const int MAXX = 1000'000'000;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    for (int i = 1; i < argc; i++) {
        string s = string(argv[i]);
        if (s.find("=") != string::npos) {
            auto pos = s.find("=");
            params[s.substr(0, pos)] = s.substr(pos + 1);
        } else {
            params[s] = "";
        }
    }
    int maxsum = get("maxsum", MAXS);
    int n = get("n", MAXN);
    int b = get("b", 0);
    int X = get("X", 0);
    vector<int> cnt;
    int sum = 0;
    for (int x = 1; sum + x <= maxsum; x++) {
        sum += x;
        cnt.push_back(x);
    }
    assert(cnt.size() >= n);
    shuffle(cnt.begin(), cnt.end());
    cout << n << " " << b << " " << X << "\n";
    for (int i = 0; i < n; i++) {
        cout << cnt[i];
        if (i + 1 < n) {
            cout << " ";
        } else {
            cout << "\n";
        }
    }
    return 0;
}
