#include "testlib.h"
#include <cassert>

using namespace std;

int n, m, q, c;
int fa, fb;

vector<int> cura, curb;
vector<pair<vector<int>, vector<int>>> tests;

void rec(int i) {
	if (i == n) {
		tests.push_back({cura, curb});
		return;
	}
	for (int ai = -1; ai <= c; ++ai) {
		for (int bi = -1; bi <= c; ++bi) {
			if (fa == 0 && ai == -1) continue;
			if (fb == 0 && bi == -1) continue;
			cura[i] = ai;
			curb[i] = bi;
			if (i != 0 && cura[i] == -1 && cura[i - 1] == -1) {
			    return;
			}
			if (i != 0 && curb[i] == -1 && curb[i - 1] == -1) {
			    return;
			}
			rec(i + 1);
		}
	}
}

vector<vector<int>> qrs;

void addtest(vector<int> a, vector<int> b) {
	for (int i = 0; i < n; ++i) {
		if (a[i] != -1 && a[i] != cura[i]) {
			cura[i] = a[i];
			qrs.push_back({1, i + 1, a[i]});
		}
	}
	for (int i = 0; i < n; ++i) {
		if (b[i] != -1 && b[i] != curb[i]) {
			curb[i] = b[i];
			qrs.push_back({2, i + 1, b[i]});
		}
	}
	for (int i = 0; i < n; ++i) {
		if (a[i] != cura[i]) {
			cura[i] = a[i];
			qrs.push_back({1, i + 1, a[i]});
		}
	}
	for (int i = 0; i < n; ++i) {
		if (b[i] != curb[i]) {
			curb[i] = b[i];
			qrs.push_back({2, i + 1, b[i]});
		}
	}
}

void fillin() {
	while ((int)qrs.size() < q) {
		int t = rnd.next(1, 2);
		int p = rnd.next(0, n - 1);
		int x = t == 1 ? cura[p] : curb[p];
		qrs.push_back({t, p + 1, x});
	}
}

int main(int argc, char *argv[]) {
	registerGen(argc, argv, 1);

	n = opt<int>("n");
	q = opt<int>("q");
	c = opt<int>("c");
	fa = opt<int>("fa");
	fb = opt<int>("fb");

	cura.resize(n);
	curb.resize(n);

	rec(0);

	cura = tests[0].first;
	curb = tests[0].second;

	println(n, c, q);
	println(cura);
	println(curb);

	for (int i = 1; i < (int)tests.size(); ++i) {
		addtest(tests[i].first, tests[i].second);
	}
	
	assert((int)qrs.size() <= q);

	fillin();

	for (auto v : qrs) {
		println(v[0], v[1], v[2]);
	}
}
