#include "testlib.h"

using namespace std;

vector<int> genseq(int n, int c, int f, int L, int R) {
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		a[i] = rnd.next(L, R);
	}
	sort(a.begin(), a.end());
	if (f != 0) {
		for (int i = 0; i < n; ++i) {
			if (rnd.next(0, f - 1) == 0) {
				if ((i == 0 || a[i - 1] != -1) && (i == n - 1 || a[i + 1] != -1)) {
					a[i] = -1;
				}
			}
		}
	}
	return a;
}

int genx(int n, int p, const vector<int> &a, int c, int f, int L, int R) {
	int l = L, r = R;
	for (int i = p - 1; i >= 0; --i) {
		if (a[i] != -1) {
			l = a[i];
			break;
		}
	}
	for (int i = p + 1; i < n; ++i) {
		if (a[i] != -1) {
			r = a[i];
			break;
		}
	}
	int x = rnd.next(l, r);
	if (f != 0 && rnd.next(0, f - 1) == 0) {
		if ((p == 0 || a[p - 1] != -1) && (p == n - 1 || a[p + 1] != -1)) {
			x = -1;
		}
	}
	return x;
}

int main(int argc, char *argv[]) {
	registerGen(argc, argv, 1);

	int n = opt<int>("n");
	int c = opt<int>("c");
	int q = opt<int>("q");
	int fa = opt<int>("fa");
	int fb = opt<int>("fb");
	
	int La = 0;
	int Ra = c / 3;
	int Lb = c / 3 * 2;
	int Rb = c;

	auto a = genseq(n, c, fa, La, Ra);
	auto b = genseq(n, c, fb, Lb, Rb);

	println(n, c, q);
	println(a);
	println(b);

	for (int i = 0; i < q; ++i) {
		int t = rnd.next(1, 2);
		int p = rnd.next(0, n - 1);
		int x;

		if (t == 1) {
			x = genx(n, p, a, c, fa, La, Ra);
			a[p] = x;
		} else {
			x = genx(n, p, b, c, fb, Lb, Rb);
			b[p] = x;
		}

		println(t, p + 1, x);
	}

}
