#include "testlib.h"
#include <cassert>

using namespace std;

int n, c, q;

vector<int> cura, curb;
vector<vector<int>> qrs;

void addtest(vector<int> a, vector<int> b) {
	for (int i = 0; i < n; ++i) {
		if (a[i] != -1 && a[i] != cura[i]) {
			cura[i] = a[i];
			qrs.push_back({1, i + 1, a[i]});
		}
	}
	for (int i = 0; i < n; ++i) {
		if (b[i] != -1 && b[i] != curb[i]) {
			curb[i] = b[i];
			qrs.push_back({2, i + 1, b[i]});
		}
	}
	for (int i = 0; i < n; ++i) {
		if (a[i] != cura[i]) {
			cura[i] = a[i];
			qrs.push_back({1, i + 1, a[i]});
		}
	}
	for (int i = 0; i < n; ++i) {
		if (b[i] != curb[i]) {
			curb[i] = b[i];
			qrs.push_back({2, i + 1, b[i]});
		}
	}
}

void fillin() {
	while ((int)qrs.size() < q) {
		int t = rnd.next(1, 2);
		int p = rnd.next(0, n - 1);
		int x = t == 1 ? cura[p] : curb[p];
		qrs.push_back({t, p + 1, x});
	}
}

int main(int argc, char *argv[]) {
	registerGen(argc, argv, 1);

	n = 1;
	c = opt<int>("c");
	q = opt<int>("q");

	vector<int> sta = {0};
	vector<int> stb = {0};

	cura = sta;
	curb = stb;

	for (int i = 0; i <= min(c, 50); ++i) {
		for (int j = max(0, c - 50); j <= c; ++j) {			
			addtest({-1}, {-1});
			addtest({j}, {j});
			addtest({i}, {i});
			addtest({i}, {j});
			addtest({j}, {i});
			addtest({i}, {-1});
			addtest({j}, {-1});
			addtest({-1}, {i});
			addtest({-1}, {j});
		}
	}

	while ((int)qrs.size() + 2 * n <= q) {
		int x = rnd.next(-1, c);
		int y = rnd.next(-1, c);
		addtest({x}, {y});
	}

	fillin();

	println(n, c, q);
	println(sta);
	println(stb);
	for (auto v : qrs) {
		println(v[0], v[1], v[2]);
	}
}
