#include "testlib.h"

using namespace std;

int n, c, q;

vector<int> a, b;

vector<int> t, p, x;

void check(int i) {
	if (i >= 0 && i < n - 1) {
		ensuref(a[i] != -1 || a[i + 1] != -1, "a[%d]=-1 and a[%d]=-1", i + 1, i + 2);
		ensuref(b[i] != -1 || b[i + 1] != -1, "b[%d]=-1 and b[%d]=-1", i + 1, i + 2);
	}
}

void checkg8(int i) {
	vector<int> aa, bb;
	for (int j = max(0, i - 1); j <= min(n - 1, i + 1); ++j) {
		if (a[j] != -1) {
			aa.push_back(a[j]);
		}
	}
	for (int j = max(0, i - 1); j <= min(n - 1, i + 1); ++j) {
		if (b[j] != -1) {
			bb.push_back(b[j]);
		}
	}
	ensuref(is_sorted(aa.begin(), aa.end()), "a not sorted");
	ensuref(is_sorted(bb.begin(), bb.end()), "b not sorted");
}

const int MAXN[] = {100'000, 5, 1, 100, 300, 1000, 100'000, 100'000, 100'000, 100'000};
const int MAXQ[] = {100'000, 100, 100'000, 100, 300, 1000, 100'000, 100'000, 100'000, 100'000};
const int MAXC[] = {1000'000'000, 5, 1000'000'000, 100, 300, 1000'000'000, 1000'000'000, 1000'000'000, 1000'000'000, 1000'000'000};

int main(int argc, char *argv[]) {
	registerValidation(argc, argv);

	int group = (!validator.group().empty() ? stoi(validator.group()) : 0);
    ensuref(0 <= group && group <= 9, "Incorrect group number");

	n = inf.readInt(1, MAXN[group], "n");
	inf.readSpace();
	c = inf.readInt(0, MAXC[group], "c");
	inf.readSpace();
	q = inf.readInt(0, MAXQ[group], "q");
	inf.readEoln();

	a = inf.readInts(n, -1, c, "a");
	inf.readEoln();
	b = inf.readInts(n, -1, c, "b");
	inf.readEoln();

	for (int i = 0; i < n - 1; ++i) {
		check(i);
	}
	
	if (group == 8) {
		for (int i = 0; i < n; ++i) {
			checkg8(i);
		}
	}

	if (q != 0) {
		t.resize(q);
		p.resize(q);
		x.resize(q);
	}

	for (int i = 0; i < q; ++i) {
		t[i] = inf.readInt(1, 2, format("t[%d]", i + 1));
		inf.readSpace();
		p[i] = inf.readInt(1, n, format("p[%d]", i + 1));
		inf.readSpace();
		x[i] = inf.readInt(-1, c, format("x[%d]", i + 1));
		inf.readEoln();

		--p[i];
	}

	inf.readEof();

	for (int i = 0; i < q; ++i) {
		if (t[i] == 1) {
			a[p[i]] = x[i];
		} else {
			b[p[i]] = x[i];
		}
		check(p[i] - 1);
		check(p[i]);
		if (group == 8) {
			checkg8(p[i]);
		}
	}
	
	if (group == 6) {
		for (int i = 0; i < n; ++i) {
			ensuref(a[i] != -1, "a[%d]=-1", i + 1);
			ensuref(b[i] != -1, "b[%d]=-1", i + 1);
		}

		for (int i = 0; i < q; ++i) {
			ensuref(x[i] != -1, "x[%d]=-1", i + 1);
		}
	}

	if (group == 7) {
		for (int i = 0; i < n; ++i) {
			ensuref(a[i] != -1, "a[%d]=-1", i + 1);
		}

		for (int i = 0; i < q; ++i) {
			if (t[i] == 1) {
				ensuref(x[i] != -1, "x[%d]=-1", i + 1);
			}
		}
	}
	return 0;
}


