#include <cassert>
#include <initializer_list>
#include <numeric>
#include <vector>
#include <iostream>
#include <utility>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <math.h>

using namespace std;

#define pii pair<int, int>
#define mp make_pair
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define ll long long
#define pb emplace_back

const int INF = 1e9 + 10;
const ll INFLL = 1e18;
const int mod = 1e9 + 7;

int C;

int add(int a, int b) {
    int res = a + b;
    if (res >= mod) {
        res -= mod;
    }
    return res;
}

int sub(int a, int b) {
    int res = a - b;
    if (res < 0) {
        res += mod;
    }
    return res;
}

int mul(int a, int b) {
    ll res = (ll)a * b;
    res %= mod;
    return res;
}

pii count_boundries(const vector<int> &a, int pos) {
    int l = 0, r = C;
    if (a[pos] != -1) {
        l = a[pos];
        r = a[pos];
    }
    if (pos > 0 && a[pos - 1] != -1) {
        l = max(l, a[pos - 1]);
    }
    if (pos + 1 < a.size() && a[pos + 1] != -1) {
        r = min(r, a[pos + 1]);
    }
    return mp(l, r);
}

int solve_for_fixed_arrays(const vector<int> &a, const vector<int> &b) {
    int ans = 0;
    int n = a.size();
    for (int i = 0; i < n; i++) {
        int coef = 1;
        for (int j = 0; j < n; j++) {
            if (j == i) {
                continue;
            }
            pii x = count_boundries(a, j);
            pii y = count_boundries(b, j);
            coef = mul(coef, max(0, x.second - x.first + 1));
            coef = mul(coef, max(0, y.second - y.first + 1));
        }
        pii x = count_boundries(a, i);
        pii y = count_boundries(b, i);
        for (int j = x.first; j <= x.second; j++) {
            for (int k = y.first; k <= y.second; k++) {
                ans = add(ans, mul(coef, abs(j - k)));
            }
        }
    }
    return ans;
}

void solve() {
    int n, q;
    cin >> n >> C >> q;
    vector<int> a(n);
    for (auto &c : a) {
        cin >> c;
    }
    vector<int> b(n);
    for (auto &c : b) {
        cin >> c;
    }
    cout << solve_for_fixed_arrays(a, b) << "\n";
    while (q--) {
        int t, p, x;
        cin >> t >> p >> x;
        if (t == 1) {
            a[p - 1] = x;
        } else {
            b[p - 1] = x;
        }
        cout << solve_for_fixed_arrays(a, b) << "\n";
    }
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
