#include <bits/stdc++.h>

using namespace std;

const int md = 1e9 + 7;

int add(int a, int b) {
	return a + b < md ? a + b : a + b - md;
}

int sub(int a, int b) {
	return a - b >= 0 ? a - b : a - b + md;
}

int mul(int a, int b) {
	return a * 1ll * b % md;
}

int pw(int a, int n) {
	int ret = 1;
	while (n > 0) {
		if (n & 1) {
			ret = mul(ret, a);
		}
		a = mul(a, a);
		n >>= 1;
	}
	return ret;
}

int inv(int a) {
	return pw(a, md - 2);
}

int inv2, inv6;

int sumpr(int n) {
	return n <= 0 ? 0 : mul(n, mul(n + 1, inv2));
}

int sumpr(int l, int r) {
	return l >= r ? 0 : sub(sumpr(r - 1), sumpr(l - 1));
}

int sumsq(int n) {
	// n*(n+1)*(2n+1)/6
	return n <= 0 ? 0 : mul(n, mul(add(n, 1), mul(add(mul(n, 2), 1), inv6)));
}

int sumsq(int l, int r) {
	return l >= r ? 0 : sub(sumsq(r - 1), sumsq(l - 1));
}

int sumt(int l1, int r1, int l2, int r2) {
	++r1;
	++r2;

	// max(0, min(t,r1)-l1)*max(0, r2-max(t,l2))
	// t>=l1
	// t<r2
	// (min(t,r1)-l1)*(r2-max(t,l2))

	vector<int> ts = {l1, r1, l2, r2};
	sort(ts.begin(), ts.end());
	ts.resize(unique(ts.begin(), ts.end()) - ts.begin());
	int ret = 0;
	for (int i = 0; i + 1 < (int)ts.size(); ++i) {
		int lt = ts[i];
		int rt = ts[i + 1];
		if (lt >= r2 || lt < l1) {
			continue;
		}
		if (lt >= r1 && lt < l2) {
			// (r1-l1)*(r2-l2)

			ret = add(ret, mul(rt - lt, mul(r1 - l1, r2 - l2)));
		}
		if (lt >= r1 && lt >= l2) {
			// (r1-l1)*(r2-t)

			// (r1-l1)*r2*(rt-lt)
			// (r1-l1)*-sumpr(lt,rt)

			ret = add(ret, mul(rt - lt, mul(r1 - l1, r2)));
			ret = sub(ret, mul(r1 - l1, sumpr(lt, rt)));
		}
		if (lt < r1 && lt < l2) {
			// (t-l1)*(r2-l2)

			// sumpr(lt,rt)*(r2-l2)
			// -l1*(r2-l2)*(rt-lt)

			ret = add(ret, mul(sumpr(lt, rt), r2 - l2));
			ret = sub(ret, mul(l1, mul(r2 - l2, rt - lt)));
		}
		if (lt < r1 && lt >= l2) {
			// (t-l1)*(r2-t)
			
			// t*r2-t^2-l1*r2+l1*t
			
			// (l1+r2)*sumpr(lt,rt)
			// -l1*r2*(rt-lt)
			// -sumsq(lt,rt)

			ret = add(ret, mul(add(l1, r2), sumpr(lt, rt)));
			ret = sub(ret, mul(l1, mul(r2, rt - lt)));
			ret = sub(ret, sumsq(lt, rt));
		}
	}

	return ret;
}

int sumabs(int l1, int r1, int l2, int r2) {
	int ret = 0;
	for (int x = l1; x <= r1; ++x) {
		if (l2 <= x) {
			int mx = x - l2;
			int mn = max(x - r2, 0);
			ret = add(ret, mul(add(mn, mx), mul(inv2, mx - mn + 1)));
		}
		if (r2 >= x) {
			int mx = r2 - x;
			int mn = max(l2 - x, 0);
			ret = add(ret, mul(add(mn, mx), mul(inv2, mx - mn + 1)));
		}
	}
	return ret;
	// return add(sumt(l1, r1, l2, r2), sumt(l2, r2, l1, r1));
}

const int N = 3e5 + 7;

int n, C, q;
int a[N], b[N];
int s[N], w[N], iw[N];
int prod, sum;
int cnt0;

void calc(int i) {
	if (a[i] != -1 && a[i - 1] != -1 && a[i] < a[i - 1]) {
		s[i] = w[i] = 0;
		return;
	}
	if (b[i] != -1 && b[i - 1] != -1 && b[i] < b[i - 1]) {
		s[i] = w[i] = 0;
		return;
	}
	if (a[i + 1] != -1 && a[i] != -1 && a[i + 1] < a[i]) {
		s[i] = w[i] = 0;
		return;
	}
	if (b[i + 1] != -1 && b[i] != -1 && b[i + 1] < b[i]) {
		s[i] = w[i] = 0;
		return;
	}
	int l1, r1, l2, r2;
	if (a[i] == -1) {
		l1 = a[i - 1];
		r1 = a[i + 1];
	} else {
		l1 = r1 = a[i];
	}
	if (b[i] == -1) {
		l2 = b[i - 1];
		r2 = b[i + 1];
	} else {
		l2 = r2 = b[i];
	}
	if (l1 > r1 || l2 > r2) {
		s[i] = w[i] = 0;
	} else {
		s[i] = sumabs(l1, r1, l2, r2);
		w[i] = mul(add(sub(r1, l1), 1), add(sub(r2, l2), 1));
		iw[i] = inv(w[i]);
	}
}

int getans() {
	return cnt0 > 0 ? 0 : mul(prod, sum);
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	inv2 = inv(2);
	inv6 = inv(6);
	cin >> n >> C >> q;
	a[0] = b[0] = 0;
	a[n + 1] = b[n + 1] = C;
	for (int i = 1; i <= n; ++i) {
		cin >> a[i];
	}
	for (int i = 1; i <= n; ++i) {
		cin >> b[i];
	}
	prod = 1;
	sum = 0;
	cnt0 = 0;
	for (int i = 1; i <= n; ++i) {
		calc(i);
		if (w[i] == 0) {
			++cnt0;
		} else {
			prod = mul(prod, w[i]);
			iw[i] = inv(w[i]);
			sum = add(sum, mul(s[i], iw[i]));
		}
	}
	cout << getans() << "\n";
	while (q--) {
		int t, p, x;
		cin >> t >> p >> x;
		for (int i = max(1, p - 1); i <= min(n, p + 1); ++i) {
			if (w[i] == 0) {
				--cnt0;
			} else {
				prod = mul(prod, iw[i]); 
				sum = sub(sum, mul(s[i], iw[i]));
			}
		}
		if (t == 1) {
			a[p] = x;
		} else {
			b[p] = x;
		}
		for (int i = max(1, p - 1); i <= min(n, p + 1); ++i) {
			calc(i);
			if (w[i] == 0) {
				++cnt0;
			} else {
				prod = mul(prod, w[i]);
				sum = add(sum, mul(s[i], iw[i]));
			}
		}
		cout << getans() << "\n";
		// for (int i = 1; i <= n; ++i) {
		// 	cout << a[i] << " ";
		// }
		// cout << endl;
	}
	return 0;
}
