#include "testlib.h"
#include <iostream>
#include <vector>

using namespace std;

const int max_n = 1'000'000'000;

int my_rand(int mx) { return rnd.wnext(mx, 0); }


enum SideForJump {
    BACK,
    FORWARD
};

void biggest_answer_one_side(int n, int pos, SideForJump side) {
    vector<int> del(n + 1, 0);
    for (int i = 2; i <= n; i++) {
        if (i % 2 == 0) {  // block size is set to be even
            for (int j = i; j <= n; j += i) {
                ++del[j];
            }
        }
    }
    if (side == SideForJump::FORWARD) {
        cout << (max_element(del.begin(), del.end() - pos) - del.begin()) + pos << endl;  // index of biggest number in range [0, n - pos + 1]
        cout << pos << endl;
    } else if (side == SideForJump::BACK) {
        cout << (max_element(del.begin() + pos - 2, del.end()) - del.begin()) - pos + 2 << endl;  // index of biggest number in range [pos - 2 , n]
        cout << pos << endl;
    }
}

void biggest_answer(int n, int pos) {
    vector<int> del(n + 1, 0);
    for (int i = 2; i <= n; i++) {
        if (i % 2 == 0) {  // block size is set to be even
            for (int j = i; j <= n; j += i) {
                ++del[j];
            }
        }
    }
    pair<int, int> answer = {0, 0};
    for (int i = pos; i + pos - 2 <= n; i++) {
        answer = max(answer, make_pair(del[i - pos] + del[i + pos - 2], i));
    }
    cout << answer.second << endl;
    cout << pos << endl;
}

signed main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    
    string mode = opt<string>("mode");
    
    if (mode == "zero") {
        cout << 9 << endl << 2 << endl;
        return 0;
    }
    
    if (mode == "corner_case") {
        /*
         if we say that k can be 1 then we will have a case like:
         1 1 1 1 1 1 1 1 1 1
         this test checks it
        */
        cout << 2 << endl << 1 << endl;
        return 0;
    }
    
    int n = opt<int>("n", max_n / 100);
    int pos = opt<int>("pos", my_rand(min(n - 1, 1000)) + 1);
    
    if (mode == "biggest_answer_one_side") {
        string side = opt<string>("side");
        if (side != "back" && side != "forward") {
            return 228;
        }
        biggest_answer_one_side(n, pos, (side == "forward" ? SideForJump::FORWARD : SideForJump::BACK));
    } else if (mode == "nothing") {
        cout << n << endl;
        cout << pos << endl;
    } else if (mode == "biggest_answer") {
        biggest_answer(n, pos);
    } else if (mode == "power_of_t") {
        int t = opt<int>("t");
        int cur = 1;
        while (1ll * cur * t + pos <= n) {
            cur *= t;
        }
        cout << cur + pos << endl;
        cout << pos << endl;
    } else if (mode == "random") {  // it is used for generators only
        int N = my_rand(n - 1) + 2;
        int pos = my_rand(N - 1) + 1;
        cout << N << endl;
        cout << pos << endl;
    }
    
    return 0;
}
