// Случайный перебор массивов
// При этом количество позиций (a[i] = a[i+1]) принадлежит отрезку [cnt_min, cnt_max]

#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

struct Array {
    int cnt_min, cnt_max;
    int n;
    vector<int> pos, d;

    Array(int n, int cnt_min, int cnt_max) : n(n), cnt_min(cnt_min), cnt_max(cnt_max) {
        d.assign(n-1, 0);
        for (int& x : d) x = rnd.next(0, 1) * 2 - 1;
        
        int cnt = (cnt_min + cnt_max) / 2;
        for (int cur = 0; pos.size() + 1 <= cnt; ) {
            int i = rnd.next(0, n-2);
            if (!d[i]) continue;
            d[i] = 0;
            pos.push_back(i);
        }
    }

    vector<int> GenerateArray() {
        int minh = 0, curh = 0;
        for (int x : d) minh = min(minh, curh += x);
        
        vector<int> a { 1-minh };
        for (int x : d) a.push_back(x + a.back());
        return a;
    }

    int GetNoZeroPos() {
        while (true) {
            int i = rnd.next(0, n-2);
            if (d[i] == 0) continue;
            return i;
        }
    }

    tuple<int, int, int> OrientedAddition(int i, int j, int x) {
        d[i] += x;
        d[j] -= x;
        if (i < j) {
            return make_tuple(i+2, j+1, x);
        } else {
            return make_tuple(j+2, i+1, x);
        }
    }

    // 1 <= pos.size() && pos.size() <= n-2
    tuple<int, int, int> GenerateMove() {
        // cerr << "GenerateMove" << endl;
        swap(pos[rnd.next(0, (int)pos.size()-1)], pos.back());
        int i = pos.back();
        int j = GetNoZeroPos();
        pos.back() = j;
        return OrientedAddition(i, j, d[j]);
    }

    // pos.size() <= n-3
    tuple<int, int, int> GenerateAdd() {
        // cerr << "GenerateAdd, |pos|=" << pos.size() << endl;
        int i = GetNoZeroPos();
        int j = i;
        while (i == j) j = GetNoZeroPos();
        
        auto res =  OrientedAddition(i, j, 1);
        if (!d[i]) pos.push_back(i);
        if (!d[j]) pos.push_back(j);
        return res;
    }

    // pos.size() >= 2
    tuple<int, int, int> GenerateErase() {
        // cerr << "GenerateErase" << endl;
        swap(pos[rnd.next(0, (int)pos.size()-1)], pos[pos.size()-1]);
        swap(pos[rnd.next(0, (int)pos.size()-2)], pos[pos.size()-2]);
        auto res = OrientedAddition(pos[pos.size()-2], pos[pos.size()-1], 1);
        pos.pop_back(), pos.pop_back();
        return res;
    }

    tuple<int, int, int> GenerateAction() {
        bool can_add = 0 <= pos.size() && pos.size() + 2 <= cnt_max;
        bool can_mov = 1 <= pos.size() && pos.size() <= n - 2;
        bool can_ers = pos.size() >= 2 + cnt_min;

        ensuref(can_add || can_mov || can_ers, "fuck you");

        while (true) {
            int i = rnd.next(0, 2);
            if (i == 0 && can_add) return GenerateAdd();
            if (i == 1 && can_mov) return GenerateMove();
            if (i == 2 && can_ers) return GenerateErase();
        }
    }
};

int main(int argc, char* argv[]) {
    ios::sync_with_stdio(0); cin.tie(0);
    registerGen(argc, argv, 1);

    map<string, int> args;
    args["t"] = 2;
    
    for (int i = 1; i != argc; ++i) {
        string opt = argv[i];
        auto pos = opt.find('=');
        if (pos != string::npos) {
            args[opt.substr(0, pos)] = stoi(opt.substr(pos+1));
        }
    }

    const int n = args["n"];
    const int q = args["q"];
    const int cnt_min = args["cnt_min"];
    const int cnt_max = args["cnt_max"];
    const int max_t = args["t"];

    ensuref(0 <= cnt_min && cnt_max < n, "[cnt_min, cnt_max] incorrect");
    ensuref(2 <= n, "n must be greater than 2");

    Array a(n, cnt_min, cnt_max);
    Array b(n, cnt_min, cnt_max);

    println(n, n, q);
    println(a.GenerateArray());
    println(b.GenerateArray());

    for (int i = 0; i < q; ++i) {
        int t = rnd.next(1, max_t);
        auto [l, r, x] = t == 1 ? a.GenerateAction() : b.GenerateAction();
        cout << t << " " << l << " " << r << " " << x << endl; 
    }
}