#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

constexpr int MIN_VALUE = -1'000'000'000;
constexpr int MAX_VALUE = +1'000'000'000;

array<map<char, int>, 9> limitations{{
    {{'N', 300'000}, {'M', 300'000}, {'Q', 300'000}, {'T', 2}},
    {{'N', 80},      {'M', 80},      {'Q', 0},       {'T', 0}},
    {{'N', 500},     {'M', 500},     {'Q', 0},       {'T', 0}},
    {{'N', 5000},    {'M', 5000},    {'Q', 0},       {'T', 0}},
    {{'N', 100'000}, {'M', 100'000}, {'Q', 100'000}, {'T', 1}},
    {{'N', 100'000}, {'M', 100'000}, {'Q', 100'000}, {'T', 2}},
    {{'N', 300'000}, {'M', 300'000}, {'Q', 0},       {'T', 1}},
    {{'N', 300'000}, {'M', 300'000}, {'Q', 300'000}, {'T', 1}},
    {{'N', 300'000}, {'M', 300'000}, {'Q', 300'000}, {'T', 2}},
}};

int main(int argc, char* argv[]) {
    ios::sync_with_stdio(0); cin.tie(0);
    registerValidation(argc, argv);

    int group = (!validator.group().empty() ? stoi(validator.group()) : 0);
    ensuref(0 <= group && group < limitations.size(), "Incorrect group number");
    const auto& limit = limitations[group];

    int n = inf.readInt(1, limit.at('N'), "n"); inf.readSpace();
    int m = inf.readInt(1, limit.at('M'), "m"); inf.readSpace();
    int q = inf.readInt(0, limit.at('Q'), "q"); inf.readEoln();

    auto a = inf.readInts(n, MIN_VALUE, MAX_VALUE, "a"); inf.readEoln();
    auto b = inf.readInts(m, MIN_VALUE, MAX_VALUE, "b"); inf.readEoln();

    for (int i = 0; i < q; ++i) {
        int t = inf.readInt(1, limit.at('T'), "t"); inf.readSpace();
        int l = inf.readInt(1, t == 1 ? n : m, "l"); inf.readSpace();
        int r = inf.readInt(l, t == 1 ? n : m, "r"); inf.readSpace();
        int x = inf.readInt(MIN_VALUE, MAX_VALUE, "x"); inf.readEoln();
    }

    inf.readEof();
}