#include <cassert>
#include <initializer_list>
#include <numeric>
#include <vector>
#include <iostream>
#include <utility>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <math.h>
#include <unordered_set>

using namespace std;

#define pii pair<int, int>
#define mp make_pair
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define ll long long
#define pb emplace_back

const int INF = 1e9 + 10;
const ll INFLL = 1e18;

ll ans = 0;
unordered_set<int> lensa;
unordered_set<int> lensb;

vector<ll> counta;
vector<ll> countb;

int n, m;

void get_segments(vector<ll> &a, vector<ll> b) {
    lensa.clear();
    lensb.clear();
    counta.assign(n + 1, 0);
    countb.assign(m + 1, 0);
    int lst = -1;
    for (int i = 0; i < n; i++) {
        if (i == n - 1 || a[i + 1] == a[i]) {
            counta[i - lst]++;
            lensa.insert(i - lst);
            lst = i;
        }
    }
    lst = -1;
    for (int i = 0; i < m; i++) {
        if (i == m - 1 || b[i + 1] == b[i]) {
            countb[i - lst]++;
            lensb.insert(i - lst);
            lst = i;
        }
    }
}

void calc_answer() {
    ans = 0;
    for (auto &w : lensa) {
        for (auto &h : lensb) {
            ll t = min(w, h);
            ans += counta[w] * countb[h] *
                   (t * (w + 1) * (h + 1) - t * (t + 1) / 2 * (2 + w + h) +
                    t * (t + 1) * (2 * t + 1) / 6);
        }
    }
}

void solve() {
    int q;
    cin >> n >> m >> q;
    counta.resize(n + 1);
    countb.resize(m + 1);
    vector<ll> a(n);
    vector<ll> b(m);
    for (auto &c : a) {
        cin >> c;
    }
    for (auto &c : b) {
        cin >> c;
    }
    get_segments(a, b);
    calc_answer();
    cout << ans << "\n";
    while (q--) {
        int t, l, r, x;
        cin >> t >> l >> r >> x;
        if (t == 1) {
            for (int i = l - 1; i < r; i++) {
                a[i] += x;
            }
        } else {
            for (int i = l - 1; i < r; i++) {
                b[i] += x;
            }
        }
        get_segments(a, b);
        calc_answer();
        cout << ans << "\n";
    }
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
