#include <cassert>
#include <initializer_list>
#include <numeric>
#include <vector>
#include <iostream>
#include <utility>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <math.h>
#include <unordered_set>

using namespace std;

#define pii pair<int, int>
#define mp make_pair
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define ll long long
#define pb emplace_back

const int INF = 1e9 + 10;
const ll INFLL = 1e18;

ll ans = 0;
vector<ll> a;
vector<ll> b;
unordered_set<int> lensa;
unordered_set<int> lensb;

vector<ll> counta;
vector<ll> countb;

int n, m;

set<pii> segsa;
set<pii> segsb;

void build_segments() {
    lensa.clear();
    lensb.clear();
    counta.assign(n + 1, 0);
    countb.assign(m + 1, 0);
    int lst = -1;
    for (int i = 0; i < n; i++) {
        if (i == n - 1 || a[i + 1] == a[i]) {
            counta[i - lst]++;
            lensa.insert(i - lst);
            segsa.insert(mp(lst + 1, i));
            lst = i;
        }
    }
    lst = -1;
    for (int i = 0; i < m; i++) {
        if (i == m - 1 || b[i + 1] == b[i]) {
            countb[i - lst]++;
            lensb.insert(i - lst);
            segsb.insert(mp(lst + 1, i));
            lst = i;
        }
    }
}

void calc_answer() {
    ans = 0;
    for (auto &w : lensa) {
        for (auto &h : lensb) {
            ll t = min(w, h);
            ans += counta[w] * countb[h] *
                   (t * (w + 1) * (h + 1) - t * (t + 1) / 2 * (2 + w + h) +
                    t * (t + 1) * (2 * t + 1) / 6);
        }
    }
}

void change_segment_state(int arr_num, int len, int change) {
    if (arr_num == 1) {
        for (auto &h : lensb) {
            ll t = min(len, h);
            ans += countb[h] *
                   (t * (len + 1) * (h + 1) - t * (t + 1) / 2 * (2 + len + h) +
                    t * (t + 1) * (2 * t + 1) / 6) *
                   change;
        }
        if (change == 1) {
            lensa.insert(len);
            counta[len]++;
        } else {
            counta[len]--;
            if (counta[len] == 0) {
                lensa.erase(len);
            }
        }
    } else {
        for (auto &w : lensa) {
            ll t = min(len, w);
            ans += counta[w] *
                   (t * (w + 1) * (len + 1) - t * (t + 1) / 2 * (2 + w + len) +
                    t * (t + 1) * (2 * t + 1) / 6) *
                   change;
        }
        if (change == 1) {
            lensb.insert(len);
            countb[len]++;
        } else {
            countb[len]--;
            if (countb[len] == 0) {
                lensb.erase(len);
            }
        }
    }
}

void solve() {
    int q;
    cin >> n >> m >> q;
    lensa.reserve(2 * n);
    lensb.reserve(2 * m);
    counta.resize(n + 1);
    countb.resize(m + 1);
    a.resize(n);
    b.resize(m);
    for (auto &c : a) {
        cin >> c;
    }
    for (auto &c : b) {
        cin >> c;
    }
    vector<ll> da(n + 1);
    vector<ll> db(m + 1);
    da[0] = a[0];
    db[0] = b[0];
    for (int i = 1; i < n; i++) {
        da[i] = a[i] - a[i - 1];
    }
    for (int i = 1; i < m; i++) {
        db[i] = b[i] - b[i - 1];
    }
    build_segments();
    calc_answer();
    cout << ans << "\n";
    while (q--) {
        int t, l, r, x;
        cin >> t >> l >> r >> x;
        l--;
        r--;
        if (t == 1) {
            if (l > 0 && da[l] != 0 && da[l] + x == 0) {
                auto it = segsa.lower_bound(mp(l, l));
                it--;
                int left = it->fi;
                int right = it->se;
                change_segment_state(1, right - left + 1, -1);
                change_segment_state(1, (l - 1) - left + 1, 1);
                change_segment_state(1, right - l + 1, 1);
                segsa.erase(mp(left, right));
                segsa.insert(mp(left, l - 1));
                segsa.insert(mp(l, right));
            }
            if (l > 0 && da[l] == 0 && da[l] + x != 0) {
                auto it = segsa.lower_bound(mp(l, l));
                int left2 = it->fi;
                int right2 = it->se;
                it--;
                int left1 = it->fi;
                int right1 = it->se;
                change_segment_state(1, right1 - left1 + 1, -1);
                change_segment_state(1, right2 - left2 + 1, -1);
                change_segment_state(1, right2 - left1 + 1, 1);
                segsa.erase(mp(left1, right1));
                segsa.erase(mp(left2, right2));
                segsa.insert(mp(left1, right2));
            }
            if (r + 1 < n && da[r + 1] != 0 && da[r + 1] - x == 0) {
                auto it = segsa.lower_bound(mp(r + 1, r + 1));
                it--;
                int left = it->fi;
                int right = it->se;
                change_segment_state(1, right - left + 1, -1);
                change_segment_state(1, r - left + 1, 1);
                change_segment_state(1, right - (r + 1) + 1, 1);
                segsa.erase(mp(left, right));
                segsa.insert(mp(left, r));
                segsa.insert(mp(r + 1, right));
            }
            if (r + 1 < n && da[r + 1] == 0 && da[r + 1] - x != 0) {
                auto it = segsa.lower_bound(mp(r + 1, r + 1));
                int left2 = it->fi;
                int right2 = it->se;
                it--;
                int left1 = it->fi;
                int right1 = it->se;
                change_segment_state(1, right1 - left1 + 1, -1);
                change_segment_state(1, right2 - left2 + 1, -1);
                change_segment_state(1, right2 - left1 + 1, 1);
                segsa.erase(mp(left1, right1));
                segsa.erase(mp(left2, right2));
                segsa.insert(mp(left1, right2));
            }
            da[l] += x;
            da[r + 1] -= x;
        } else {
            if (l > 0 && db[l] != 0 && db[l] + x == 0) {
                auto it = segsb.lower_bound(mp(l, l));
                it--;
                int left = it->fi;
                int right = it->se;
                change_segment_state(2, right - left + 1, -1);
                change_segment_state(2, (l - 1) - left + 1, 1);
                change_segment_state(2, right - l + 1, 1);
                segsb.erase(mp(left, right));
                segsb.insert(mp(left, l - 1));
                segsb.insert(mp(l, right));
            }
            if (l > 0 && db[l] == 0 && db[l] + x != 0) {
                auto it = segsb.lower_bound(mp(l, l));
                int left2 = it->fi;
                int right2 = it->se;
                it--;
                int left1 = it->fi;
                int right1 = it->se;
                change_segment_state(2, right1 - left1 + 1, -1);
                change_segment_state(2, right2 - left2 + 1, -1);
                change_segment_state(2, right2 - left1 + 1, 1);
                segsb.erase(mp(left1, right1));
                segsb.erase(mp(left2, right2));
                segsb.insert(mp(left1, right2));
            }
            if (r + 1 < m && db[r + 1] != 0 && db[r + 1] - x == 0) {
                auto it = segsb.lower_bound(mp(r + 1, r + 1));
                it--;
                int left = it->fi;
                int right = it->se;
                change_segment_state(2, right - left + 1, -1);
                change_segment_state(2, r - left + 1, 1);
                change_segment_state(2, right - (r + 1) + 1, 1);
                segsb.erase(mp(left, right));
                segsb.insert(mp(left, r));
                segsb.insert(mp(r + 1, right));
            }
            if (r + 1 < m && db[r + 1] == 0 && db[r + 1] - x != 0) {
                auto it = segsb.lower_bound(mp(r + 1, r + 1));
                int left2 = it->fi;
                int right2 = it->se;
                it--;
                int left1 = it->fi;
                int right1 = it->se;
                change_segment_state(2, right1 - left1 + 1, -1);
                change_segment_state(2, right2 - left2 + 1, -1);
                change_segment_state(2, right2 - left1 + 1, 1);
                segsb.erase(mp(left1, right1));
                segsb.erase(mp(left2, right2));
                segsb.insert(mp(left1, right2));
            }
            db[l] += x;
            db[r + 1] -= x;
        }
        cout << ans << "\n";
    }
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
