#include <bits/stdc++.h>

using namespace std;
using ll = long long;

ll square_count(ll n, ll m) {
    ll ans = 0;

    if (n < m) {
        ans += n*(n-1)*(2*n-1)/6 - n*(n-1)/2*n;
        ans += n*(n+1)/2 * m;
    } else {
        ans += m*(m-1)*(2*m-1)/6 - m*(m-1)/2*m;
        ans += m*(m+1)/2 * n;
    }

    return ans;
}

ll solve(vector<ll>& a, const vector<ll>& b) {
    const int n = a.size(), m = b.size();
    vector<int> cnt_a(n+1), cnt_b(m+1);

    for (int i = 0; i < n; ) {
        int j = i++;
        while (i < n && a[i] != a[i-1]) ++i;
        cnt_a[i-j]++;
    }

    for (int i = 0; i < m; ) {
        int j = i++;
        while (i < m && b[i] != b[i-1]) ++i;
        cnt_b[i-j]++;
    }

    vector<int> lens_a, lens_b;
    for (int i = 0; i <= n; ++i) if (cnt_a[i]) lens_a.push_back(i);
    for (int i = 0; i <= m; ++i) if (cnt_b[i]) lens_b.push_back(i);

    ll ans = 0;
    for (int x : lens_a)
    for (int y : lens_b) {
        ans += (ll)cnt_a[x]*cnt_b[y]*square_count(x, y);
    }

    return ans;
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    int n, m, q; cin >> n >> m >> q;
    vector<ll> a(n), b(m);
    for (ll& x : a) cin >> x;
    for (ll& x : b) cin >> x;

    cout << solve(a, b) << '\n';
    while (q--) {
        int t, l, r, x; cin >> t >> l >> r >> x; --l;
        if (t == 1) for (int i = l; i != r; ++i) a[i] += x;
        if (t == 2) for (int i = l; i != r; ++i) b[i] += x;
        cout << solve(a, b) << '\n';
    }
}